#include "StdAfx.h"

myIDirect3D9Ex::myIDirect3D9Ex(IDirect3D9Ex *pOriginal)
{
    m_pIDirect3D9Ex = pOriginal;
}

myIDirect3D9Ex::~myIDirect3D9Ex(void)
{
}

HRESULT  __stdcall myIDirect3D9Ex::QueryInterface(REFIID riid, void** ppvObj)
{
    *ppvObj = NULL;

	// call this to increase AddRef at original object
	// and to check if such an interface is there

	HRESULT hRes = m_pIDirect3D9Ex->QueryInterface(riid, ppvObj); 

	if (hRes == NOERROR) // if OK, send our "fake" address
	{
		*ppvObj = this;
	}
	
	return hRes;
}

ULONG    __stdcall myIDirect3D9Ex::AddRef(void)
{
    return(m_pIDirect3D9Ex->AddRef());
}

ULONG    __stdcall myIDirect3D9Ex::Release(void)
{
    extern myIDirect3D9Ex* gl_pmyIDirect3D9Ex;

	// call original routine
	ULONG count = m_pIDirect3D9Ex->Release();
	
	DB(L"GPROXY: Object Release RetVal=",(int)count); 

    // in case no further Ref is there, the Original Object has deleted itself
	// so do we here
	if (count == 0) 
	{
		gl_pmyIDirect3D9Ex = NULL;
  	    delete(this); 
	}

	return(count);
}

HRESULT __stdcall myIDirect3D9Ex::RegisterSoftwareDevice(void* pInitializeFunction)
{
    return(m_pIDirect3D9Ex->RegisterSoftwareDevice(pInitializeFunction));
}

UINT __stdcall myIDirect3D9Ex::GetAdapterCount(void)
{
    return(m_pIDirect3D9Ex->GetAdapterCount());
}

HRESULT __stdcall myIDirect3D9Ex::GetAdapterIdentifier(UINT Adapter,DWORD Flags,D3DADAPTER_IDENTIFIER9* pIdentifier)
{
    return(m_pIDirect3D9Ex->GetAdapterIdentifier(Adapter,Flags,pIdentifier));
}

UINT __stdcall myIDirect3D9Ex::GetAdapterModeCount(UINT Adapter, D3DFORMAT Format)
{
    return(m_pIDirect3D9Ex->GetAdapterModeCount(Adapter, Format));
}

HRESULT __stdcall myIDirect3D9Ex::EnumAdapterModes(UINT Adapter,D3DFORMAT Format,UINT Mode,D3DDISPLAYMODE* pMode)
{
    return(m_pIDirect3D9Ex->EnumAdapterModes(Adapter,Format,Mode,pMode));
}

HRESULT __stdcall myIDirect3D9Ex::GetAdapterDisplayMode( UINT Adapter,D3DDISPLAYMODE* pMode)
{
    return(m_pIDirect3D9Ex->GetAdapterDisplayMode(Adapter,pMode));
}

HRESULT __stdcall myIDirect3D9Ex::CheckDeviceType(UINT iAdapter,D3DDEVTYPE DevType,D3DFORMAT DisplayFormat,D3DFORMAT BackBufferFormat,BOOL bWindowed)
{
    return(m_pIDirect3D9Ex->CheckDeviceType(iAdapter,DevType,DisplayFormat,BackBufferFormat,bWindowed));
}

HRESULT __stdcall myIDirect3D9Ex::CheckDeviceFormat(UINT Adapter,D3DDEVTYPE DeviceType,D3DFORMAT AdapterFormat,DWORD Usage,D3DRESOURCETYPE RType,D3DFORMAT CheckFormat)
{
    return(m_pIDirect3D9Ex->CheckDeviceFormat(Adapter,DeviceType,AdapterFormat,Usage,RType,CheckFormat));
}

HRESULT __stdcall myIDirect3D9Ex::CheckDeviceMultiSampleType(UINT Adapter,D3DDEVTYPE DeviceType,D3DFORMAT SurfaceFormat,BOOL Windowed,D3DMULTISAMPLE_TYPE MultiSampleType,DWORD* pQualityLevels)
{
    return(m_pIDirect3D9Ex->CheckDeviceMultiSampleType(Adapter,DeviceType,SurfaceFormat,Windowed,MultiSampleType,pQualityLevels));
}

HRESULT __stdcall myIDirect3D9Ex::CheckDepthStencilMatch(UINT Adapter,D3DDEVTYPE DeviceType,D3DFORMAT AdapterFormat,D3DFORMAT RenderTargetFormat,D3DFORMAT DepthStencilFormat)
{
    return(m_pIDirect3D9Ex->CheckDepthStencilMatch(Adapter,DeviceType,AdapterFormat,RenderTargetFormat,DepthStencilFormat));
}

HRESULT __stdcall myIDirect3D9Ex::CheckDeviceFormatConversion(UINT Adapter,D3DDEVTYPE DeviceType,D3DFORMAT SourceFormat,D3DFORMAT TargetFormat)
{
    return(m_pIDirect3D9Ex->CheckDeviceFormatConversion(Adapter,DeviceType,SourceFormat,TargetFormat));
}

HRESULT __stdcall myIDirect3D9Ex::GetDeviceCaps(UINT Adapter,D3DDEVTYPE DeviceType,D3DCAPS9* pCaps)
{
    return(m_pIDirect3D9Ex->GetDeviceCaps(Adapter,DeviceType,pCaps));
}

HMONITOR __stdcall myIDirect3D9Ex::GetAdapterMonitor(UINT Adapter)
{
    return(m_pIDirect3D9Ex->GetAdapterMonitor(Adapter));
}

HRESULT __stdcall myIDirect3D9Ex::CreateDevice(UINT Adapter,D3DDEVTYPE DeviceType,HWND hFocusWindow,DWORD BehaviorFlags,D3DPRESENT_PARAMETERS* pPresentationParameters,IDirect3DDevice9** ppReturnedDeviceInterface)
{
    // global var
	extern myIDirect3DDevice9* gl_pmyIDirect3DDevice9;

	// we intercept this call and provide our own "fake" Device Object
	HRESULT hres = m_pIDirect3D9Ex->CreateDevice( Adapter, DeviceType, hFocusWindow, BehaviorFlags, pPresentationParameters, ppReturnedDeviceInterface);
    
	// Create our own Device object and store it in global pointer
	// note: the object will delete itself once Ref count is zero (similar to COM objects)
	gl_pmyIDirect3DDevice9 = new myIDirect3DDevice9(*ppReturnedDeviceInterface);
	
	// store our pointer (the fake one) for returning it to the calling progam
	*ppReturnedDeviceInterface = gl_pmyIDirect3DDevice9;

	return(hres); 
}

UINT __stdcall myIDirect3D9Ex::GetAdapterModeCountEx(UINT Adapter,CONST D3DDISPLAYMODEFILTER* pFilter)
{
	return(m_pIDirect3D9Ex->GetAdapterModeCountEx(Adapter,pFilter));
}

HRESULT __stdcall myIDirect3D9Ex::EnumAdapterModesEx(UINT Adapter,CONST D3DDISPLAYMODEFILTER* pFilter,UINT Mode,D3DDISPLAYMODEEX* pMode)
{
	return(m_pIDirect3D9Ex->EnumAdapterModesEx(Adapter,pFilter,Mode,pMode));
}

HRESULT __stdcall myIDirect3D9Ex::GetAdapterDisplayModeEx(UINT Adapter,D3DDISPLAYMODEEX* pMode,D3DDISPLAYROTATION* pRotation)
{
	return(m_pIDirect3D9Ex->GetAdapterDisplayModeEx(Adapter,pMode,pRotation));
}

HRESULT __stdcall myIDirect3D9Ex::CreateDeviceEx(UINT Adapter,D3DDEVTYPE DeviceType,HWND hFocusWindow,DWORD BehaviorFlags,D3DPRESENT_PARAMETERS* pPresentationParameters,D3DDISPLAYMODEEX* pFullscreenDisplayMode,IDirect3DDevice9Ex** ppReturnedDeviceInterface)
{
	DB(L"GPROXY: myIDirect3D9::CreateDeviceEx called\r\n");

	// global var
	extern myIDirect3DDevice9Ex* gl_pmyIDirect3DDevice9Ex;

	// we intercept this call and provide our own "fake" Device Object
	HRESULT hres = m_pIDirect3D9Ex->CreateDeviceEx( Adapter, DeviceType, hFocusWindow, BehaviorFlags, pPresentationParameters, pFullscreenDisplayMode, ppReturnedDeviceInterface);
    
	// Create our own Device object and store it in global pointer
	// note: the object will delete itself once Ref count is zero (similar to COM objects)
	gl_pmyIDirect3DDevice9Ex = new myIDirect3DDevice9Ex(*ppReturnedDeviceInterface);
	
	// store our pointer (the fake one) for returning it to the calling progam
	*ppReturnedDeviceInterface = gl_pmyIDirect3DDevice9Ex;

	return(hres); 
}

HRESULT __stdcall myIDirect3D9Ex::GetAdapterLUID(UINT Adapter,LUID * pLUID)
{
	return(m_pIDirect3D9Ex->GetAdapterLUID(Adapter,pLUID));
}
